rm(list=ls())
setwd("C:/your_folder/with_data/")		# Customize this to your local installation

library(foreign)
library(np)

datos <- read.table(file="hj.csv",
                        sep = ",",dec=".",header=TRUE)
datos <- datos[datos$age==31,]
                        
nmulti <- 5
tol <- 0.01
ftol <- 0.01
bwmethod <- "cv.ml"
bandwidth.compute <- TRUE
ckertype <- "gaussian"
ckerorder <- 2

ptm <- proc.time()
attach(datos)
oiid <- order(unique(ts))
otid <- order(unique(year))
iid <- unique(ts)[oiid]
tid <- unique(year)[otid]

b <- vector(mode="numeric",length=length(tid))

for(jt in 1:length(tid)){
eval(parse(text=paste("bw",tid[jt],"<- npudensbw(dat=log(rasset[year==tid[jt]]),tol=tol,ftol=ftol,nmulti=nmulti,bwmethod=bwmethod,bandwidth.compute=bandwidth.compute,ckertype=ckertype,ckerorder=ckerorder)",sep="")))
b[jt]<-eval(parse(text=paste("bw",tid[jt],"$bandwidth$x",sep="")))
print(c(tid[jt],b[jt]))
eval(parse(text=paste("bwg",tid[jt],"<- npudensbw(dat=log(rasset[year==tid[jt]]),","bws=c(",b[jt],"^(5/4))",",bandwidth.compute=FALSE,ckertype=ckertype,ckerorder=ckerorder)",sep="")))
eval(parse(text=paste("bwgr",tid[jt],"<- npudensbw(dat=log(rasset[year==tid[jt]]),","bws=c(",b[jt],"*length(tid)^(-1/5))",",bandwidth.compute=FALSE,ckertype=ckertype,ckerorder=ckerorder)",sep="")))
}
save(list=ls(),file="hj3.Rdata")
detach(datos)
print(proc.time() - ptm)